Index: issm/trunk/src/m/coordsystems/ll2xy.py
===================================================================
--- issm/trunk/src/m/coordsystems/ll2xy.py	(revision 25994)
+++ issm/trunk/src/m/coordsystems/ll2xy.py	(revision 26744)
@@ -2,38 +2,50 @@
 
 
-def ll2xy(lat, lon, sgn=-1, central_meridian=0, standard_parallel=71):
-    '''
-    LL2XY - converts lat lon to polar stereographic
+def ll2xy(lat, lon, sgn, *args):
+    """LL2XY - converts lat lon to polar stereographic
 
-   Converts from geodetic latitude and longitude to Polar
-   Stereographic (X, Y) coordinates for the polar regions.
-   Author: Michael P. Schodlok, December 2003 (map2ll)
+    Converts from geodetic latitude and longitude to Polar
+    Stereographic (X, Y) coordinates for the polar regions.
+    Author: Michael P. Schodlok, December 2003 (map2ll)
 
-   Usage:
-      x, y = ll2xy(lat, lon, sgn)
-      x, y = ll2xy(lat, lon, sgn, central_meridian, standard_parallel)
+    Usage:
+        x, y = ll2xy(lat, lon, sgn)
+        x, y = ll2xy(lat, lon, sgn, central_meridian, standard_parallel)
 
- - sgn = Sign of latitude	1 : north latitude (default is mer = 45 lat = 70)
- 						   -1 : south latitude (default is mer = 0  lat = 71)
-    '''
+    - sgn = Sign of latitude	1 : north latitude (default is mer = 45 lat = 70)
+    						   -1 : south latitude (default is mer = 0  lat = 71)
+    """
+    assert sgn == 1 or sgn == -1, 'error: sgn should be either 1 or -1'
+	 
+	 # Get central_meridian and standard_parallel depending on hemisphere
+    if len(args) == 2:
+       delta = args[0]
+       slat = args[1]
+    elif len(args) == 0:
+       if sgn == 1:
+          delta = 45.
+          slat = 70.
+          print('        ll2xy: creating coordinates in north polar stereographic (Std Latitude: 70degN Meridian: 45deg)')
+       elif sgn == -1:
+          delta = 0.
+          slat = 71.
+          print('        ll2xy: creating coordinates in south polar stereographic (Std Latitude: 71degS Meridian: 0deg)')
+       else:
+          raise ValueError('sgn should be either 1 or -1')
+    else:
+       raise Exception('bad usage: type "help(ll2xy)" for details')
 
-    assert sgn == 1 or sgn == -1, 'error: sgn should be either 1 or -1'
-
-    #Get central_meridian and standard_parallel depending on hemisphere
-    if sgn == 1:
-        delta = 45
-        slat = 70
-        print('        ll2xy: creating coordinates in north polar stereographic (Std Latitude: 70N Meridian: 45)')
-    else:
-        delta = central_meridian
-        slat = standard_parallel
-        print('        ll2xy: creating coordinates in south polar stereographic (Std Latitude: 71S Meridian: 0)')
+    # if lat, lon passed as lists, convert to np.arrays
+    if type(lat) != "np.ndarray":
+       lat = np.array(lat)
+    if type(lon) != "np.ndarray":
+       lon = np.array(lon)
 
     # Conversion constant from degrees to radians
     #cde = 57.29577951
     # Radius of the earth in meters
-    re = 6378.273 * 10**3
+    re = 6378.273 * pow(10, 3)
     # Eccentricity of the Hughes ellipsoid squared
-    ex2 = .006693883
+    ex2 = 0.006693883
     # Eccentricity of the Hughes ellipsoid
     ex = np.sqrt(ex2)
@@ -58,6 +70,7 @@
     cnt1 = np.nonzero(latitude >= np.pi / 2.)[0]
 
-    if cnt1:
-        x[cnt1, 0] = 0.0
-        y[cnt1, 0] = 0.0
+    if len(cnt1)>0:
+        x[cnt1] = 0.0
+        y[cnt1] = 0.0
+
     return x, y
Index: issm/trunk/src/m/coordsystems/xy2ll.py
===================================================================
--- issm/trunk/src/m/coordsystems/xy2ll.py	(revision 25994)
+++ issm/trunk/src/m/coordsystems/xy2ll.py	(revision 26744)
@@ -4,6 +4,5 @@
 
 def xy2ll(x, y, sgn, *args):
-    '''
-    XY2LL - converts xy to lat long
+    """XY2LL - converts xy to lat long
 
     Converts Polar  Stereographic (X, Y) coordinates for the polar regions to
@@ -13,12 +12,12 @@
 
     Usage:
-       [lat, lon] = xy2ll(x, y, sgn)
-       [lat, lon] = xy2ll(x, y, sgn, central_meridian, standard_parallel)
+        [lat, lon] = xy2ll(x, y, sgn)
+        [lat, lon] = xy2ll(x, y, sgn, central_meridian, standard_parallel)
 
-     - sgn = Sign of latitude	1 : north latitude (default is mer = 45 lat = 70)
-     						   -1 : south latitude (default is mer = 0  lat = 71)
-    '''
+    - sgn = Sign of latitude	1 : north latitude (default is mer = 45 lat = 70)
+    						   -1 : south latitude (default is mer = 0  lat = 71)
+    """
 
-    #Get central_meridian and standard_parallel depending on hemisphere
+    # Get central_meridian and standard_parallel depending on hemisphere
     if len(args) == 2:
         delta = args[0]
@@ -47,11 +46,11 @@
     #cde = 57.29577951
     # Radius of the earth in meters
-    re = 6378.273 * 10**3
+    re = 6378.273 * pow(10, 3)
     # Eccentricity of the Hughes ellipsoid squared
-    ex2 = .006693883
+    ex2 = 0.006693883
     # Eccentricity of the Hughes ellipsoid
     ex = np.sqrt(ex2)
 
-    sl = slat * pi / 180.
+    sl = slat * pi / 180.0
     rho = np.sqrt(x**2 + y**2)
     cm = np.cos(sl) / np.sqrt(1.0 - ex2 * (np.sin(sl)**2))
Index: issm/trunk/src/m/dev/ISSM.py
===================================================================
--- issm/trunk/src/m/dev/ISSM.py	(revision 25994)
+++ issm/trunk/src/m/dev/ISSM.py	(revision 26744)
@@ -4,5 +4,4 @@
 import scipy.io as spio
 from model import *
-from socket import gethostname
 from triangle import *
 from setmask import *
@@ -10,5 +9,6 @@
 from setflowequation import *
 from solve import *
-from IssmConfing import *
+from IssmConfig import *
+from MatlabFuncs import *
 
 #Secondary imports
Index: issm/trunk/src/m/dev/devpath.m
===================================================================
--- issm/trunk/src/m/dev/devpath.m	(revision 25994)
+++ issm/trunk/src/m/dev/devpath.m	(revision 26744)
@@ -3,9 +3,10 @@
 
 %Recover ISSM_DIR , or if on a Windows machine, ISSM_DIR_WIN
-if ~ispc,
+if ispc,
+	ISSM_DIR=getenv('ISSM_DIR_WIN');
+else
 	ISSM_DIR=getenv('ISSM_DIR');
-else
-	ISSM_DIR=getenv('ISSM_DIR_WIN');
 end
+
 if (isempty(ISSM_DIR)),
 	error('''ISSM_DIR'' environment variable is empty! You should define ISSM_DIR in your .cshrc or .bashrc!');
@@ -18,5 +19,5 @@
 %ISSM path
 addpath([ISSM_DIR '/src/m/os/']); %load recursivepath
-addpath([ISSM_DIR '/lib']);       %load mex
+addpath([ISSM_DIR '/lib']);       %load MEX files
 addpath(recursivepath([ISSM_DIR '/src/m']));
 addpath(recursivepath([ISSM_DIR '/externalpackages/scotch']));
@@ -28,4 +29,5 @@
 addpath(recursivepath([ISSM_DIR '/externalpackages/dem']));
 addpath(recursivepath([ISSM_DIR '/externalpackages/mealpix']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/pcatool']));
 clear ISSM_DIR;
 
Index: issm/trunk/src/m/dev/devpath.py
===================================================================
--- issm/trunk/src/m/dev/devpath.py	(revision 25994)
+++ issm/trunk/src/m/dev/devpath.py	(revision 26744)
@@ -2,5 +2,4 @@
 import os
 import sys
-import warnings
 
 #Recover ISSM_DIR and USERNAME
@@ -16,6 +15,6 @@
         dirs.remove('.svn')
     for file in files:
-        if file.find(".py") != -1:
-            if file.find(".pyc") == -1:
+        if file.find('.py') != -1:
+            if file.find('.pyc') == -1:
                 if root not in sys.path:
                     sys.path.append(root)
@@ -36,5 +35,5 @@
             sys.path.append(jpl_path)
     else:
-        warnings.warn('cluster settings should be in, {}/usr/{}'.format(JPL_SVN, USERNAME))
+        print('Warning: devpath.py: cluster settings should be in {}'.format(jpl_path))
 
 from runme import runme  #first because plotmodel may fail
@@ -47,4 +46,4 @@
 #c.InteractiveShellApp.exec_lines.append('print "Warning: disable autoreload in startup.py to improve performance." ')
 
-print("\n  ISSM development path correctly loaded")
-print("Current path is {}\n\n".format(ISSM_DIR))
+# print("\n  ISSM development path correctly loaded")
+# print("Current path is {}\n\n".format(ISSM_DIR))
Index: issm/trunk/src/m/dev/issmversion.m
===================================================================
--- issm/trunk/src/m/dev/issmversion.m	(revision 25994)
+++ issm/trunk/src/m/dev/issmversion.m	(revision 26744)
@@ -17,5 +17,5 @@
 disp(['Compiled on ' IssmConfig('HOST_VENDOR') ' ' IssmConfig('HOST_OS') ' ' IssmConfig('HOST_ARCH') ' by ' IssmConfig('USER_NAME')]);
 disp([' ']);
-disp(['Copyright (c) 2009-2020 California Institute of Technology']);
+disp(['Copyright (c) 2009-2021 California Institute of Technology']);
 disp([' ']);
 disp(['    to get started type: issmdoc']);
Index: issm/trunk/src/m/dev/issmversion.py
===================================================================
--- issm/trunk/src/m/dev/issmversion.py	(revision 25994)
+++ issm/trunk/src/m/dev/issmversion.py	(revision 26744)
@@ -16,5 +16,5 @@
 print(' ')
 print(('Build date: ' + IssmConfig('PACKAGE_BUILD_DATE')[0]))
-print('Copyright (c) 2009 - 2020 California Institute of Technology')
+print('Copyright (c) 2009-2021 California Institute of Technology')
 print(' ')
 print('    to get started type: issmdoc')
Index: issm/trunk/src/m/exp/contourlevelzero.m
===================================================================
--- issm/trunk/src/m/exp/contourlevelzero.m	(revision 25994)
+++ issm/trunk/src/m/exp/contourlevelzero.m	(revision 26744)
@@ -1,6 +1,6 @@
 function contours=contourlevelzero(md,mask,level)
-%CONTOURLEVELZERO - figure out the zero level (or offset thereof, specified by 
-%the level value) of a vectorial mask, and vectorialize it into an exp or shp 
-%compatible structure.
+%CONTOURLEVELZERO - figure out the zero level (or offset thereof, specified by the level value) 
+%                   of a vectorial mask, and vectorialize it into an exp or shp compatible 
+%structure.
 %
 %   Usage:
@@ -9,10 +9,7 @@
 %   See also: PLOT_CONTOUR
 
-if isempty(mask)
-	error('mask provided is empty');
-end
-
 %process data 
 if dimension(md.mesh)==3,
+% 	error('contourlevelzero error message: routine not supported for 3d meshes, project on a layer');
 	x = md.mesh.x2d;
 	y = md.mesh.y2d;
@@ -24,5 +21,5 @@
 end
 
-if isfield(md.mesh,'z'),
+if isprop(md.mesh,'z'),
 	z=md.mesh.z;
 else
@@ -30,6 +27,7 @@
 end
 
+if isempty(mask), error('mask provided is empty'); end
 if dimension(md.mesh)==3,
-	if length(mask)~=md.mesh.numberofvertices2d, error('Since this is a 3d model, you need to project the mask on a layer (e.g. project2d(md,mask,0))'); end
+	if length(mask)~=md.mesh.numberofvertices2d, error('mask provided should be specified at the vertices of the mesh'); end
 else
 	if length(mask)~=md.mesh.numberofvertices, error('mask provided should be specified at the vertices of the mesh'); end
Index: issm/trunk/src/m/exp/contourlevelzero.py
===================================================================
--- issm/trunk/src/m/exp/contourlevelzero.py	(revision 26744)
+++ issm/trunk/src/m/exp/contourlevelzero.py	(revision 26744)
@@ -0,0 +1,237 @@
+import os.path
+import numpy as np
+from collections import OrderedDict
+
+def contourlevelzero(md,mask,level):
+    """CONTOURLEVELZERO - figure out the zero level (or offset thereof, specified by the level value)
+                       of a vectorial mask, and vectorialize it into an exp or shp compatible structure.
+    
+       Usage:
+          contours=contourlevelzero(md,mask,level)
+    
+       See also: PLOT_CONTOUR
+    """
+    
+    #process data 
+    if md.mesh.dimension()==3:
+        x = md.mesh.x2d
+        y = md.mesh.y2d
+        z=md.mesh.z
+        index=md.mesh.elements2d-1
+    else:
+        x=md.mesh.x
+        y=md.mesh.y
+        index=md.mesh.elements-1
+        z=np.zeros((md.mesh.numberofvertices,1))
+        
+    if len(mask)==0:
+        raise OSError("mask provided is empty")
+    
+    if md.mesh.dimension()==3:
+        if len(mask)!=md.mesh.numberofvertices2d: 
+            raise OSError("mask provided should be specified at the vertices of the mesh")
+    else:
+        if len(mask)!=md.mesh.numberofvertices:
+            raise OSError("mask provided should be specified at the vertices of the mesh")
+        
+    #initialization of some variables
+    numberofelements=np.size(index,0)
+    elementslist=np.c_[0:numberofelements]
+    c=[]
+    h=[]
+    
+    #get unique edges in mesh
+    #1: list of edges
+    edges=np.vstack((np.vstack((index[:,(0,1)],index[:,(1,2)])),index[:,(2,0)]))
+
+    #2: find unique edges
+    [edges,J]=np.unique(np.sort(edges,1),axis=0,return_inverse=True)
+    #3: unique edge numbers
+    vec=J
+    #4: unique edges numbers in each triangle (2 triangles sharing the same edge will have
+    #   the same edge number)
+    edges_tria=np.hstack((np.hstack((vec[elementslist],vec[elementslist+numberofelements])),vec[elementslist+2*numberofelements]))
+    
+    #segments [nodes1 nodes2]
+    Seg1=index[:,(0,1)]
+    Seg2=index[:,(1,2)]
+    Seg3=index[:,(2,0)]
+    
+    #segment numbers [1;4;6;...]
+    Seg1_num=edges_tria[:,0]
+    Seg2_num=edges_tria[:,1]
+    Seg3_num=edges_tria[:,2]
+    
+    #value of data on each tips of the segments
+    Data1=mask[Seg1]
+    Data2=mask[Seg2]
+    Data3=mask[Seg3]
+    
+    #get the ranges for each segment
+    Range1=np.sort(Data1,1)
+    Range2=np.sort(Data2,1)
+    Range3=np.sort(Data3,1)
+    
+    #find the segments that contain this value
+    pos1=(Range1[:,0]<level) & (Range1[:,1]>=level)
+    pos2=(Range2[:,0]<level) & (Range2[:,1]>=level)
+    pos3=(Range3[:,0]<level) & (Range3[:,1]>=level)
+    
+    #get elements
+    poselem12=(pos1) & (pos2)
+    poselem13=(pos1) & (pos3)
+    poselem23=(pos2) & (pos3)
+    poselem=np.where((poselem12) | (poselem13) | (poselem23))
+    poselem=poselem[0]
+    numelems=len(poselem)
+    
+    #if no element has been flagged, skip to the next level
+    if numelems==0:
+        raise Exception('contourlevelzero warning message: no elements found with corresponding level value in mask')
+        contours=[]
+        return contours
+    
+    #go through the elements and build the coordinates for each segment (1 by element)
+    x1=np.zeros((numelems,1))
+    x2=np.zeros((numelems,1))
+    y1=np.zeros((numelems,1))
+    y2=np.zeros((numelems,1))
+    z1=np.zeros((numelems,1))
+    z2=np.zeros((numelems,1))
+    
+    edge_l=np.zeros((numelems,2))
+    
+    for j in range(0,numelems):
+        
+        with np.errstate(divide='ignore', invalid='ignore'):
+            weight1=np.divide(level-Data1[poselem[j],0],Data1[poselem[j],1]-Data1[poselem[j],0])
+            weight2=np.divide(level-Data2[poselem[j],0],Data2[poselem[j],1]-Data2[poselem[j],0])
+            weight3=np.divide(level-Data3[poselem[j],0],Data3[poselem[j],1]-Data3[poselem[j],0])
+        
+        if poselem12[poselem[j]]==True:
+            
+            x1[j]=x[Seg1[poselem[j],0]]+weight1*[x[Seg1[poselem[j],1]]-x[Seg1[poselem[j],0]]]
+            x2[j]=x[Seg2[poselem[j],0]]+weight2*[x[Seg2[poselem[j],1]]-x[Seg2[poselem[j],0]]]
+            y1[j]=y[Seg1[poselem[j],0]]+weight1*[y[Seg1[poselem[j],1]]-y[Seg1[poselem[j],0]]]
+            y2[j]=y[Seg2[poselem[j],0]]+weight2*[y[Seg2[poselem[j],1]]-y[Seg2[poselem[j],0]]]
+            z1[j]=z[Seg1[poselem[j],0]]+weight1*[z[Seg1[poselem[j],1]]-z[Seg1[poselem[j],0]]]
+            z2[j]=z[Seg2[poselem[j],0]]+weight2*[z[Seg2[poselem[j],1]]-z[Seg2[poselem[j],0]]]
+            
+            edge_l[j,0]=Seg1_num[poselem[j]]
+            edge_l[j,1]=Seg2_num[poselem[j]]
+        elif poselem13[poselem[j]]==True:
+            
+            x1[j]=x[Seg1[poselem[j],0]]+weight1*[x[Seg1[poselem[j],1]]-x[Seg1[poselem[j],0]]]
+            x2[j]=x[Seg3[poselem[j],0]]+weight3*[x[Seg3[poselem[j],1]]-x[Seg3[poselem[j],0]]]
+            y1[j]=y[Seg1[poselem[j],0]]+weight1*[y[Seg1[poselem[j],1]]-y[Seg1[poselem[j],0]]]
+            y2[j]=y[Seg3[poselem[j],0]]+weight3*[y[Seg3[poselem[j],1]]-y[Seg3[poselem[j],0]]]
+            z1[j]=z[Seg1[poselem[j],0]]+weight1*[z[Seg1[poselem[j],1]]-z[Seg1[poselem[j],0]]]
+            z2[j]=z[Seg3[poselem[j],0]]+weight3*[z[Seg3[poselem[j],1]]-z[Seg3[poselem[j],0]]]
+            
+            edge_l[j,0]=Seg1_num[poselem[j]]
+            edge_l[j,1]=Seg3_num[poselem[j]]
+        elif poselem23[poselem[j]]==True:
+            
+            x1[j]=x[Seg2[poselem[j],0]]+weight2*[x[Seg2[poselem[j],1]]-x[Seg2[poselem[j],0]]]
+            x2[j]=x[Seg3[poselem[j],0]]+weight3*[x[Seg3[poselem[j],1]]-x[Seg3[poselem[j],0]]]
+            y1[j]=y[Seg2[poselem[j],0]]+weight2*[y[Seg2[poselem[j],1]]-y[Seg2[poselem[j],0]]]
+            y2[j]=y[Seg3[poselem[j],0]]+weight3*[y[Seg3[poselem[j],1]]-y[Seg3[poselem[j],0]]]
+            z1[j]=z[Seg2[poselem[j],0]]+weight2*[z[Seg2[poselem[j],1]]-z[Seg2[poselem[j],0]]]
+            z2[j]=z[Seg3[poselem[j],0]]+weight3*[z[Seg3[poselem[j],1]]-z[Seg3[poselem[j],0]]]
+
+            edge_l[j,0]=Seg2_num[poselem[j]]
+            edge_l[j,1]=Seg3_num[poselem[j]]
+
+        #else:
+	    #it shoud not go here
+            
+    #now that we have the segments, we must try to connect them...
+    
+    #loop over the subcontours
+    contours=[]
+    
+    while len(edge_l)>0:
+        
+        #take the right edge of the second segment and connect it to the next segments if any
+        e1=edge_l[0,0]
+        e2=edge_l[0,1]
+        xc=np.vstack((x1[0],x2[0]))
+        yc=np.vstack((y1[0],y2[0]))
+        zc=np.vstack((z1[0],z2[0]))
+        #erase the lines corresponding to this edge
+        edge_l=np.delete(edge_l,0,axis=0)
+        x1=np.delete(x1,0,axis=0)
+        x2=np.delete(x2,0,axis=0)
+        y1=np.delete(y1,0,axis=0)
+        y2=np.delete(y2,0,axis=0)
+        z1=np.delete(z1,0,axis=0)
+        z2=np.delete(z2,0,axis=0)
+        pos1=np.where(edge_l==e1)
+        
+        while len(pos1[0])>0:
+            
+            if np.all(pos1[1]==0):
+                xc=np.vstack((x2[pos1[0]],xc))
+                yc=np.vstack((y2[pos1[0]],yc))
+                zc=np.vstack((z2[pos1[0]],zc))
+                #next edge:
+                e1=edge_l[pos1[0],1]
+            else:
+                xc=np.vstack((x1[pos1[0]],xc))
+                yc=np.vstack((y1[pos1[0]],yc))
+                zc=np.vstack((z1[pos1[0]],zc))
+                #next edge:
+                e1=edge_l[pos1[0],0]
+                
+            #erase the lines of this
+            edge_l=np.delete(edge_l,pos1[0],axis=0)
+            x1=np.delete(x1,pos1[0],axis=0)
+            x2=np.delete(x2,pos1[0],axis=0)
+            y1=np.delete(y1,pos1[0],axis=0)
+            y2=np.delete(y2,pos1[0],axis=0)
+            z1=np.delete(z1,pos1[0],axis=0)
+            z2=np.delete(z2,pos1[0],axis=0)
+            #next connection
+            pos1=np.where(edge_l==e1)
+            
+        #same thing the other way (to the right)
+        pos2=np.where(edge_l==e2)
+
+        while len(pos2[0])>0:
+            
+            if np.all(pos2[1]==0):
+                xc=np.vstack((xc,x2[pos2[0]]))
+                yc=np.vstack((yc,y2[pos2[0]]))
+                zc=np.vstack((zc,z2[pos2[0]]))
+                #next edge:
+                e2=edge_l[pos2[0],1]
+            else:
+                xc=np.vstack((xc,x1[pos2[0]]))
+                yc=np.vstack((yc,y1[pos2[0]]))
+                zc=np.vstack((zc,z1[pos2[0]]))
+                #next edge:
+                e2=edge_l[pos2[0],0]
+                
+            #erase the lines of this
+            edge_l=np.delete(edge_l,pos2[0],axis=0)
+            x1=np.delete(x1,pos2[0],axis=0)
+            x2=np.delete(x2,pos2[0],axis=0)
+            y1=np.delete(y1,pos2[0],axis=0)
+            y2=np.delete(y2,pos2[0],axis=0)
+            z1=np.delete(z1,pos2[0],axis=0)
+            z2=np.delete(z2,pos2[0],axis=0)
+            #next connection
+            pos2=np.where(edge_l==e2)
+            
+        #save xc,yc contour: 
+        newcontour = OrderedDict()
+        newcontour['nods'] = np.size(xc)
+        newcontour['density'] = 1 
+        newcontour['closed'] = 0
+        newcontour['x'] = np.ma.filled(xc.astype(float), np.nan)
+        newcontour['y'] = np.ma.filled(yc.astype(float), np.nan)
+        newcontour['z'] = np.ma.filled(zc.astype(float), np.nan)
+        newcontour['name'] = ''
+        contours.append(newcontour)
+        
+    return contours
Index: issm/trunk/src/m/exp/expcontourlevelzero.m
===================================================================
--- issm/trunk/src/m/exp/expcontourlevelzero.m	(revision 25994)
+++ issm/trunk/src/m/exp/expcontourlevelzero.m	(revision 26744)
@@ -6,5 +6,6 @@
 % 
 %   Example:
-%      expcontourlevelzero(md,md.geometry.thickness,0, 'Level0.exp');
+%      expcontourlevelzero(md,md.geometry.thickness,10, 'Level0.exp');
+%      expcontourlevelzero(md,md.mask.ocean_levelset,0, 'Level0.exp');
 %
 %   See also CONTOURLEVELZERO, EXPWRITE
Index: issm/trunk/src/m/exp/expwrite.py
===================================================================
--- issm/trunk/src/m/exp/expwrite.py	(revision 25994)
+++ issm/trunk/src/m/exp/expwrite.py	(revision 26744)
@@ -3,45 +3,43 @@
 
 def expwrite(contours, filename):
-    """
-    EXPWRITE - write an Argus file from a dictionary given in input
+    """EXPWRITE - write an Argus file from a dictionary given in input
 
-       This routine writes an Argus file from a dict containing the fields:
-       x and y of the coordinates of the points.
-       The first argument is the list containing the points coordinates
-       and the second one the file to be written.
+    This routine writes an Argus file from a dict containing the fields:
+    x and y of the coordinates of the points.
+    The first argument is the list containing the points coordinates and the 
+    second one the file to be written.
 
-       Usage:
-          expwrite(contours, filename)
+    Usage:
+        expwrite(contours, filename)
 
-       Example:
-          expwrite(coordstruct, 'domainoutline.exp')
+    Example:
+        expwrite(coordstruct, 'domainoutline.exp')
 
-       See also EXPDOC, EXPREAD, EXPWRITEASVERTICES
+    See also EXPDOC, EXPREAD, EXPWRITEASVERTICES
     """
 
     fid = open(filename, 'w')
     for x, y in zip(contours['x'], contours['y']):
-        #if np.size(contour['x']) != np.size(contour['y']):
         if len(x) != len(y):
-            raise RuntimeError("contours x and y coordinates must be of identical size")
+            raise RuntimeError('contours x and y coordinates must be of identical size')
+
         if 'name' in contours:
-            fid.write("%s%s\n" % ('  # Name:', contours['name']))
+            fid.write('{}{}\n'.format('# Name:', contours['name']))
         else:
-            fid.write("%s%s\n" % ('  # Name:', filename))
+            fid.write('{}{}\n'.format('# Name:', filename))
 
-        #Add density if it's not there FIXME what is this ever used for?
-        #if 'density' not in contours:
-        #    contours['density'] = 1
-        density = 1
-
-        fid.write("%s\n" % '  # Icon:0')
-        fid.write("%s\n" % '  # Points Count Value')
-    #fid.write("%i %f\n" % (np.size(contour['x']), contour['density']))
-        fid.write("%i %f\n" % (np.size(x), density))
-        fid.write("%s\n" % '  # X pos Y pos')
-    #for x, y in zip(contour['x'], contour['y']):
+        fid.write('{}\n'.format('## Icon:0'))
+        fid.write('{}\n'.format('# Points Count Value'))
+        if 'density' in contours:
+            if isinstance(contours['density'], int):
+                fid.write('{} {}\n'.format(np.size(x), contours['density']))
+            else:
+                fid.write('{} {}\n'.format(np.size(x), 1.))
+        else:
+            fid.write('{} {}\n'.format(np.size(x), 1.))
+        fid.write('{}\n'.format('# X pos Y pos'))
         for xi, yi in zip(x, y):
-            fid.write("%10.10f %10.10f\n" % (xi, yi))
-        fid.write("\n")
+            fid.write('%10.10f %10.10f\n' % (xi, yi))
+        fid.write('\n')
 
     fid.close()
Index: issm/trunk/src/m/extrusion/project3d.m
===================================================================
--- issm/trunk/src/m/extrusion/project3d.m	(revision 25994)
+++ issm/trunk/src/m/extrusion/project3d.m	(revision 26744)
@@ -7,9 +7,10 @@
 %   arguments: 
 %      'vector': 2d vector
-%      'type': 'element' or 'node'. 
+%      'type': 'element' or 'node' or 'poly'
 %   options: 
 %      'layer' a layer number where vector should keep its values. If not specified, all layers adopt the 
 %             value of the 2d vector.
 %      'padding': default to 0 (value adopted by other 3d layers not being projected0
+%		 'degree': degree of polynomials when extrude from bottom to the top
 %
 %   Egs:
@@ -33,4 +34,5 @@
 layer        = getfieldvalue(options,'layer',0);    %optional (do all layers otherwise)
 paddingvalue = getfieldvalue(options,'padding',0);  %0 by default
+polyexponent = getfieldvalue(options,'degree',0);   %0 by default, 0-degree polynomial
 
 if length(vector2d)==1,
@@ -80,4 +82,27 @@
 	end
 
+elseif strcmpi(type,'poly'), % interpolate values from 0 to 1 with a polynomial degree n
+	%Initialize 3d vector
+	if size(vector2d,1)==md.mesh.numberofvertices2d
+		projected_vector=paddingvalue*ones(md.mesh.numberofvertices, size(vector2d,2));
+	elseif size(vector2d,1)==md.mesh.numberofvertices2d+1
+		projected_vector=paddingvalue*ones(md.mesh.numberofvertices+1,size(vector2d,2));
+		projected_vector(end,:)=vector2d(end,:);
+		vector2d=vector2d(1:end-1,:);
+	else
+		error('vector length not supported')
+	end
+
+	polycoeff = [0:1./(md.mesh.numberoflayers-1):1];
+
+	%Fill in
+	if layer==0,
+		for i=1:md.mesh.numberoflayers,
+			projected_vector(((i-1)*md.mesh.numberofvertices2d+1):(i*md.mesh.numberofvertices2d),:)=vector2d*(1-(1-polycoeff(i)).^polyexponent);
+		end
+	else
+		projected_vector(((layer-1)*md.mesh.numberofvertices2d+1):(layer*md.mesh.numberofvertices2d),:)=vector2d*(1-(1-polycoeff(layer)).^polyexponent);
+	end
+
 else
 	error('project3d error message: unknown projection type');
Index: issm/trunk/src/m/extrusion/project3d.py
===================================================================
--- issm/trunk/src/m/extrusion/project3d.py	(revision 25994)
+++ issm/trunk/src/m/extrusion/project3d.py	(revision 26744)
@@ -1,4 +1,3 @@
 import numpy as np
-
 from pairoptions import pairoptions
 
@@ -8,19 +7,20 @@
     PROJECT3D - vertically project a vector from 2d mesh
 
-        vertically project a vector from 2d mesh (split in noncoll and coll 
+        vertically project a vector from 2d mesh (split in noncoll and coll
         areas) into a 3d mesh.
-        This vector can be a node vector of size (md.mesh.numberofvertices2d, 
+        This vector can be a node vector of size (md.mesh.numberofvertices2d,
         N/A) or an element vector of size (md.mesh.numberofelements2d, N/A).
 
         arguments:
             'vector': 2d vector
-            'type': 'element' or 'node'
+            'type': 'element' or 'node' or 'poly'
 
         options:
-            'layer'     a layer number where vector should keep its values. If 
-                        not specified, all layers adopt the value of the 2d 
+            'layer'     a layer number where vector should keep its values. If
+                        not specified, all layers adopt the value of the 2d
                         vector.
-            'padding':  default to 0 (value adopted by other 3d layers not 
+            'padding':  default to 0 (value adopted by other 3d layers not
                         being projected.
+            'degree':   degree of polynomials when extrude from bottom to the top
 
         Examples:
@@ -42,4 +42,5 @@
     layer = options.getfieldvalue('layer', 0)  #optional (do all layers otherwise)
     paddingvalue = options.getfieldvalue('padding', 0)  #0 by default
+    polyexponent = options.getfieldvalue('degree', 0)  #0 by default, 0-degree polynomial
 
     #Handle special case where vector2d is single element (differs from representation in MATLAB)
@@ -115,5 +116,36 @@
             else:
                 projected_vector[((layer - 1) * md.mesh.numberofelements2d):(layer * md.mesh.numberofelements2d), :] = vector2d
-
+    elif vectype.lower() == 'poly':
+        #Initialize 3d vector
+        if np.ndim(vector2d) == 1:
+            if vector2d.shape[0] == md.mesh.numberofvertices2d:
+                projected_vector = (paddingvalue * np.ones((md.mesh.numberofvertices))).astype(vector2d.dtype)
+            elif vector2d.shape[0] == md.mesh.numberofvertices2d + 1:
+                projected_vector = (paddingvalue * np.ones((md.mesh.numberofvertices + 1))).astype(vector2d.dtype)
+                projected_vector[-1] = vector2d[-1]
+                vector2d = vector2d[:-1]
+            else:
+                raise TypeError("vector length not supported")
+            #Fill in
+            if layer == 0:
+                for i in range(md.mesh.numberoflayers - 1):
+                    projected_vector[(i * md.mesh.numberofvertices2d):((i + 1) * md.mesh.numberofvertices2d)] = vector2d * (1.0 - (1.0 - i / (md.mesh.numberoflayers - 1.0))**polyexponent)
+            else:
+                projected_vector[((layer - 1) * md.mesh.numberofvertices2d):(layer * md.mesh.numberofvertices2d)] = vector2d * (1.0 - (1.0 - layer / (md.mesh.numberoflayers - 1.0))**polyexponent)
+        else:
+            if vector2d.shape[0] == md.mesh.numberofvertices2d:
+                projected_vector = (paddingvalue * np.ones((md.mesh.numberofvertices, np.size(vector2d, axis=1)))).astype(vector2d.dtype)
+            elif vector2d.shape[0] == md.mesh.numberofvertices2d + 1:
+                projected_vector = (paddingvalue * np.ones((md.mesh.numberofvertices + 1, np.size(vector2d, axis=1)))).astype(vector2d.dtype)
+                projected_vector[-1, :] = vector2d[-1, :]
+                vector2d = vector2d[:-1, :]
+            else:
+                raise TypeError("vector length not supported")
+            #Fill in
+            if layer == 0:
+                for i in range(md.mesh.numberoflayers - 1):
+                    projected_vector[(i * md.mesh.numberofvertices2d):((i + 1) * md.mesh.numberofvertices2d), :] = vector2d * (1.0 - (1.0 - i / (md.mesh.numberoflayers - 1.0))**polyexponent)
+            else:
+                projected_vector[((layer - 1) * md.mesh.numberofvertices2d):(layer * md.mesh.numberofvertices2d), :] = vector2d * (1.0 - (1.0 - layer / (md.mesh.numberoflayers - 1.0))**polyexponent)
     else:
         raise TypeError("project3d error message: unknown projection type")
Index: issm/trunk/src/m/geometry/planetradius.js
===================================================================
--- issm/trunk/src/m/geometry/planetradius.js	(revision 26744)
+++ issm/trunk/src/m/geometry/planetradius.js	(revision 26744)
@@ -0,0 +1,20 @@
+function planetradius(planet) {//{{{
+	/**
+	 * PLANETRADIUS - return planet radius according to planetary body name
+	 *
+	 * Usage:
+	 *     radius = planetradius(planet);
+	 *
+	 * Examples:
+	 * earthradius = planetradius('earth');
+	 */
+
+	let radius = 0;
+	if (planet === 'earth') {
+		radius = 6.371012e6;
+	} else if (planet === 'europa') {
+		radius = 1.5008e6;
+	} else {
+		error('planet type ' + planet + ' not supported yet!');
+	}
+} //}}}
Index: issm/trunk/src/m/interp/averaging.m
===================================================================
--- issm/trunk/src/m/interp/averaging.m	(revision 25994)
+++ issm/trunk/src/m/interp/averaging.m	(revision 26744)
@@ -73,5 +73,5 @@
 linesize=rep*numberofelements;
 
-%update weights that holds the volume of all the element holding the node i
+%update weights that hold the volume of all the element holding the node i
 weights=sparse(line,ones(linesize,1),repmat(areas,rep,1),numberofnodes,1);
 
